<style>
    
</style>
<template>
    <div>
        <div class="base_table">
            <div class="tb_title">
                <span class="tb_title_txt">
                    <span class="transaction_icon icon"></span>
                    <span>{{ lang.transaction }}</span><span class="tb_title_comments"></span>
                </span>
            </div>
            <div class="table_config" v-if="on_load">
                <div class="fakeloader">
                    <div class="fl spinner4"></div>
                </div>
            </div>
            <div class="detail_tb_ct">
                <table class="base_tb_ct" v-if="detail && !on_load">
                    <tr class="">
                        <td class="mobile_width_30p">
                            <div>
                                {{ lang.transaction_info }}
                            </div>
                        </td>
                        <td>
                            <div>
                                
                            </div>
                        </td>
                    </tr>
                    <tr class="">
                        <td>
                            <div>
                                {{ lang.transaction_id }}:
                            </div>
                        </td>
                        <td>
                            <div class="pc_module">
                                {{ detail.data[0].trx_id || detail.data[0].id }}
                            </div>
                            <div class="mobile_module">
                                {{ detail.data[0].trx_id || detail.data[0].id }}
                            </div>
                        </td>
                    </tr>
                    <tr class="">
                        <td>
                            <div>
                                {{ lang.block }}:
                            </div>
                        </td>
                        <td>
                            <div>
                                <router-link class="blue_ft" :to="{name: 'block_detail_view', params: {block_num: detail.data[0].block_num}}">{{ detail.data[0].block_num }}</router-link>
                            </div>
                        </td>
                    </tr>
                    <tr class="">
                        <td>
                            <div>
                                {{ lang.create_time }}:
                            </div>
                        </td>
                        <td>
                            <div>
                                {{ detail.data[0].block_time ? time_plus_hours(detail.data[0].block_time) : 'T' }}
                            </div>
                        </td>
                    </tr>
                    <!-- <tr class="">
                        <td>
                            <div>
                                {{ lang.status }}:
                            </div>
                        </td>
                        <td>
                            <div v-if="detail.trx">
                                {{ detail.trx.receipt.status }}
                            </div>
                        </td>
                    </tr> -->
                    <tr class="">
                        <td>
                            <div>
                                &nbsp;
                            </div>
                        </td>
                        <td>
                            <div>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
        <!-- block origin data -->
        <br/>

        

        <div class="base_table">
            <div class="tb_title tb_title_gray tb_title_white">
                <span>{{ lang.action }}</span>
            </div>
            <div class="table_config" v-if="on_load">
                <div class="fakeloader">
                    <div class="fl spinner4"></div>
                </div>
            </div>
            <div class="detail_tb_ct mobile_ct">
                <table class="base_tb_ct" v-if="!on_load">
                    <template v-for="item, index in get_detail(detail)">
                        <tr v-for="row_ob, row_index in get_row_array(item)" v-bind:class="{'tr_bg': row_index%2 == 0}">
                            <td>
                                <div class="mobile_width_60">
                                    {{ row_ob[0] }}
                                </div>
                            </td>
                            <td>
                                <div class="w_100">
                                    {{ row_ob[1] }}
                                </div>
                            </td>
                        </tr>
                    </template>
                </table>
            </div>

            <div class="detail_tb_ct pc_module">
                <table class="base_tb_ct" v-if="!on_load">
                    <thead>
                        <tr>
                            <!-- <th class="mobile_width_60">
                                {{ lang.contract }}
                            </th> -->
                            <th>
                                {{ lang.transaction_time }}
                            </th>
                            <th>
                                {{ lang.contract_name }}
                            </th>
                            <th class="mobile_width_60">
                                {{ lang.action }}
                            </th>
                            <th>
                                {{ lang.authorizer }}
                            </th>
                            <th>
                                {{ lang.transfer_direction }}
                            </th>
                            <th>
                                {{ lang.data }}
                            </th>
                        </tr>
                    </thead>
                    <tr class="" v-for="item, index in get_detail(detail)">
                        <!-- <td>
                            <div class="td_more_show w_48">
                                {{ item.trx_id }}
                            </div>
                        </td> -->
                        <td>
                            <div class="w_150">
                                {{ item.block_time ? time_plus_hours(item.block_time) : '...'  }}
                            </div>
                        </td>
                        <td>
                            <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.account}}">{{ item.account }}</router-link> 
                        </td>
                        <td>
                            <div class="w_100">
                                {{ item.name }}
                            </div>
                        </td>
                        <td>
                            <div class="w_150">
                                <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.actor}}">{{ item.actor + '@' + item.permission }}</router-link> 
                            </div>
                        </td>
                        <td>
                            <template v-for="name, index in get_related_accounts(item)" v-if="name">
                                <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: name}}">{{ name }}</router-link> 
                                <span v-if="name && index < get_related_accounts(item).length - 1">-> </span>
                            </template>
                        </td>
                        <td>
                            <div class="w_200 data_td">
                                    {{ get_data_from(item).data }}
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
        
    </div>
</template>
<script>
import {
    get_transaction_detail
} from '../../service/eos_service.js'
import {
    json_html_style,
    time_plus_hours
} from '../utils/utils.js'
import { lang } from '../../data/lang.js'
import load_fns from '../common/load_fns.js'
export default {
    data () {
        return {
            on_load: true,
            load_timestamp: new Date().getTime(),
            trx_id: '',
            detail: null,
            lang: lang.data
        }
    },
    mounted(){
        this.get_transaction_detail();
    },
    watch: {
        '$route.params.trx_id' () {
            this.get_block_detail();
        }
    },
    methods: {
        get_transaction_detail () {
            this.trx_id = this.$route.params.trx_id;
            let post_time = this.start_load(true);
            get_transaction_detail(this.trx_id)
            .then((res) => {
                if(!this.diff_data_timestamp(post_time)) return ;
                this.detail = res;
                this.finish_load();
            });
        },
        json_html_style,
        ...load_fns,
        get_row_array (row) {
            let row_array = [];
            row_array.push([
                lang.data.contract,
                row.account
            ]);
            row_array.push([
                lang.data.action,
                row.name
            ]); 
            row_array.push([
                lang.data.authorizer,
                row.actor + '@' + row.permission
            ]); 
            row_array.push([
                lang.data.data,
                this.get_data_from(row).data
            ]); 
            return row_array;
        },
        get_related_accounts (item) {
          let trans = {
                  vote: ['voter', 'bpname'],
                  claim: ['bpname', 'voter'],
                  transfer: ['actor', 'to'],
                  unfreeze: ['bpname', 'actor'],
                  issue: ['actor', 'to'],
                  create: ['actor', 'issuer'],
                  newaccount: ['actor', 'name']
              },
              _from, 
              _to = '', 
              res = [];

            let origin_data = item;
            if(trans[item['name']]){
                let action_obs = trans[item['name']];
                _from = item[action_obs[0]];
                _to = (origin_data.data ? origin_data.data[action_obs[1]] : '') || item[action_obs[1]];
            }else{
                _from = item['actor'];
                _to = item['to'] || item['account'];
            }
            _from ? res.push(_from) : '';
            _to ? res.push(_to) : '';
            return res;
        },
        get_detail (detail) {
            let res = [];
            detail.data.forEach(item => {
                let od = item
                od = Object.assign(od, item);
                res.push(od.act || od);
            });
            return res;
        },
        get_data_from (item) {
            let origin_data = JSON.parse(item.origin_data);
            return origin_data.traces ? origin_data.traces[0].act : origin_data.act;
        }
    }
}
</script>